// D92RS232CControlDlg.cpp 
//
////////////////////////////////////////////////////////////
//
//	Suruga Seiki D92 controller controlling sample program 
//
////////////////////////////////////////////////////////////					


#include "stdafx.h"
#include "D92RS232CControl.h"
#include "D92RS232CControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// SURUGA >>
#include <comdef.h>
#define LIMIT_TIME		2.0
// << SURUGA

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)

	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD92RS232CControlDlg

CD92RS232CControlDlg::CD92RS232CControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD92RS232CControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD92RS232CControlDlg)
	m_iLSpeed = 100;
	m_iPosition = 0;
	m_iRate = 200;
	m_iSpeed = 2000;
	m_strStatus = _T("");
	m_iStep = 100;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CD92RS232CControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD92RS232CControlDlg)
	DDX_Control(pDX, IDC_CW, m_pCCWButton);
	DDX_Control(pDX, IDC_CCW, m_pCWButton);
	DDX_Text(pDX, IDC_LSPEED, m_iLSpeed);
	DDV_MinMaxInt(pDX, m_iLSpeed, 0, 999);
	DDX_Text(pDX, IDC_POSITION, m_iPosition);
	DDX_Text(pDX, IDC_RATE, m_iRate);
	DDV_MinMaxInt(pDX, m_iRate, 0, 999);
	DDX_Text(pDX, IDC_SPEED, m_iSpeed);
	DDV_MinMaxInt(pDX, m_iSpeed, 1, 16000);
	DDX_Text(pDX, IDC_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_STEP, m_iStep);
	DDV_MinMaxInt(pDX, m_iStep, 0, 9999999);
	DDX_Control(pDX, IDC_MSCOMM, m_MSComm);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD92RS232CControlDlg, CDialog)
	//{{AFX_MSG_MAP(CD92RS232CControlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MODE_CONT, OnModeCont)
	ON_BN_CLICKED(IDC_MODE_ORG, OnModeOrg)
	ON_BN_CLICKED(IDC_MODE_STEP, OnModeStep)
	ON_BN_CLICKED(IDC_SET_POSITION, OnSetPosition)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_CBN_SELCHANGE(IDC_COMMPORT_NUMBER, OnSelchangePortNumber)
	ON_CBN_SELCHANGE(IDC_AXIS, OnSelchangeAxis)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MY_LBUTTON_DOWN,OnDown)
	ON_MESSAGE(WM_MY_LBUTTON_UP,OnUp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD92RS232CControlDlg

BOOL CD92RS232CControlDlg::OnInitDialog()
{
	// SURUGA >>
	m_pCWButton.SubclassDlgItem(IDC_CW,this);
	m_pCCWButton.SubclassDlgItem(IDC_CCW,this);
	// << SURUGA

	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);
	
	// SURUGA >>
	nTimerID=1;			// Initializes the ID of the timer
	bStopFlag = FALSE;
	bConnect  = FALSE;
	// Performs initialization processing of each control unit.
	SetEnableControl(FALSE);									// Makes the control units other than the control unit for setting.
	((CComboBox*)GetDlgItem(IDC_COMMPORT_NUMBER))->SetCurSel(0);	// Sets the default value (0) of the COMMportnumber
	((CComboBox*)GetDlgItem(IDC_AXIS))->SetCurSel(0);			// Sets Axis 1 as the default value of the driving axis.
	((CButton*)GetDlgItem(IDC_MODE_CONT))->SetCheck(1);			// Sets the continuous movement mode as an initial setting of the operation mode.
	((CButton*)GetDlgItem(IDOK))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDCANCEL))->EnableWindow(TRUE);

	Connect(1);					// Performs initialization processing of MSComm.
	OnSelchangeAxis();			// Performs initialization processing of the movement axis.
	// << SURUGA
	return TRUE;
}

void CD92RS232CControlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CD92RS232CControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CD92RS232CControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CD92RS232CControlDlg::OnDown(WPARAM wParam,LPARAM lParam) 
{
	// SURUGA >>
	//
	//	Processing when the movement button (CW or CCW) is pressed
	//	
	//	Examines the movement mode and performs the following processing.
	//      Continuous movement mode : Starts the movement of the stage.
	//	Others: does not do anything. Performs actual movement when the button is released.
	//

	CString strMessage;			// Buffer for transmitting commands
	if(!UpdateData(TRUE)) return;

	if (GetCheckedRadioButton(IDC_MODE_CONT,IDC_MODE_ORG) == IDC_MODE_CONT) {	// Examines the operation mode selected.
		// Starts the movement when the operation mode of the stage is a continuous movement mode.
		if (wParam == IDC_CW) strMessage.Format("P9999999L%dR%dF%dUG",m_iLSpeed,m_iRate,m_iSpeed);	// Sets the movement command for moving toward CW.
		else				  strMessage.Format("P9999999L%dR%dF%dDG",m_iLSpeed,m_iRate,m_iSpeed);	// Sets the movement command for moving toward CCW
		SendString(GetAxisString()+strMessage);		
		nTimerID = SetTimer(nTimerID,200,NULL);			// Sets the timer interruption for updating the window.
	}
	// << SURUGA
}

void CD92RS232CControlDlg::OnUp(WPARAM wParam,LPARAM lParam) 
{
	// SURUGA >>
	//
	//	Processing when the movement button is released
	//
	//	Examines the movement mode and performs the following processing.
	//		Continuous movement mode : stops the stage.
	//		Step movement mode: confirms the movement and stop of the stage.
	//		Origin reverting mode: Sets the memory switch and confirms the movement and stop of the stage.
	//
	CString strMessage;			// Buffer for transmitting the command

	switch(GetCheckedRadioButton(IDC_MODE_CONT,IDC_MODE_ORG)){		// Examines the movement mode of the stage.
	case IDC_MODE_CONT:												// Stops the stage when the operation mode is a continuous movement mode.
		OnStop();													// Stoppage of the stage
		KillTimer(nTimerID);										// Breaks the timer interruption for updating the window.
		break;
	case IDC_MODE_STEP:												// Starts the movement of the stage if the operation mode is a step movement mode.
		if (!UpdateData(TRUE)) return;
		if (wParam == IDC_CW) strMessage.Format("P%dL%dR%dF%dUG",m_iStep,m_iLSpeed,m_iRate,m_iSpeed);	// Sets the parameter when the movement direction is a CW direction.
		else				  strMessage.Format("P%dL%dR%dF%dDG",m_iStep,m_iLSpeed,m_iRate,m_iSpeed);	// Sets the parameter when the movement direction is a CCW direction.
		SetEnableControl(FALSE);									// Makes all the controls unchangeable.
		((CButton*)GetDlgItem(IDC_STOP))->EnableWindow(TRUE);		// Makes only the STOP button usable.
		bStopFlag = FALSE;											// Clears the stop flag.
		SendString(GetAxisString()+strMessage);						// Transmits the movement command.
		CheckStop();												// Confirms the stoppage.
		SetEnableControl(TRUE);										// Makes the control usable.
		break;
	case IDC_MODE_ORG:												// Sets the memory switch and reverts to the origin when the operation mode is an origin reverting mode.
		if (!UpdateData(TRUE)) return;
		SetEnableControl(FALSE);														
		((CButton*)GetDlgItem(IDC_STOP))->EnableWindow(TRUE);		// Makes only the STOP button usable.
		bStopFlag = FALSE;											// Clears the stop flag.
		strMessage.Format( "L%dR%dF%d",m_iLSpeed,m_iRate,m_iSpeed);	// Sets the command for reverting to the origin.
		SendString(GetAxisString()+strMessage);						
		SendString(GetAxisString()+"O");							// Starts the origin reversion.
		CheckStop();												// Confirms the stoppage.
		SetEnableControl(TRUE);										// Makes the control usable.
		break;
	}
	// << SURUGA
}

void CD92RS232CControlDlg::OnModeCont() 
{
	// SURUGA >>
	//
	//	Processing when the continuous movement mode is selected
	//
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(FALSE);		// Makes the edit box in the step movement mode unchangeable.
	SetButtonCaption(FALSE);									// Sets the text of the driving button.
	// << SURUGA
}

void CD92RS232CControlDlg::OnModeOrg() 
{
	// SURUGA >>
	//
	//	Processing when the origin reverting mode is selected
	//
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(FALSE);		// Makes the edit box in the step movement mode unchangeable.
	SetButtonCaption(TRUE);										// Sets the text of the driving button.
	// << SURUGA 
}

void CD92RS232CControlDlg::OnModeStep() 
{
	// SURUGA >>
	//
	//	Processing when the step movement mode is selected
	//
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(TRUE);		// Makes the edit box in the step movement mode changeable.
	SetButtonCaption(FALSE);									// Sets the text of the driving button.
	// << SURUGA
}

void CD92RS232CControlDlg::OnSetPosition() 
{
	// SURUGA >>
	//
	//	Processing when the position setting button is pressed
	//
	CSetPositionDlg dlgSetPosition;						// Dialog for setting the position
	dlgSetPosition.m_iPosition = GetPositionData();		// Makes the present position an initial value for the dialog.
	if (dlgSetPosition.DoModal()==IDOK)	{		
		m_iPosition = dlgSetPosition.m_iPosition;		// Sets a new position.
		SetPositionData(m_iPosition);
		UpdateData(FALSE);			
	}
	// << SURUGA
}

void CD92RS232CControlDlg::OnStop() 
{
	// SURUGA >>
	//
	// Processing when the STOP button is pressed
	//
	SendString("E");			// Transmits the command for stopping all the axes.
	Sleep(50);
	while (1) {
		if (GetAxisStatus() != 1) break;	// Confirms the stoppage of the axis.
	}
	bStopFlag=TRUE;							
	m_iPosition = GetPositionData();		
	UpdateData(FALSE);						
	// << SURUGA
}

void CD92RS232CControlDlg::OnTimer(UINT nIDEvent) 
{
	// SURUGA >>
	//
	// Processing when the timer interruption occurs
	//
	// Displays the status and position of the stage in the window.
	//
	GetAxisStatus();									// Updates the status for selecting the axis.
	m_iPosition = GetPositionData();					// Obtains the present position.
	UpdateData(FALSE);					

	if (nIDEvent != NULL) CDialog::OnTimer(nIDEvent);	// Carries out a basic class of implement when being called by the timer interruption.
	// CDialog::OnTimer(nIDEvent);

	// << SURUGA
}

void CD92RS232CControlDlg::OnOK() 
{
	// SURUGA >>
	//
	// Processing when the OK button is pressed
	//
	if (m_MSComm.GetPortOpen() == TRUE) m_MSComm.SetPortOpen(FALSE);
	// << SURUGA

	CDialog::OnOK();
}

void CD92RS232CControlDlg::OnCancel() 
{
	// SURUGA >>
	//
	// Processing when the Cancel button is pressed
	//
	if (m_MSComm.GetPortOpen() == TRUE) m_MSComm.SetPortOpen(FALSE);

	// << SURUGA

	CDialog::OnCancel();
}

// SURUGA >>

void CD92RS232CControlDlg::SetEnableControl(BOOL bFlag){
//
//	Routine which changes over OPERABLE or INOPERABLE of each control
//
	// Sets the OK or Cancel button.
	((CButton*)GetDlgItem(IDOK))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDCANCEL))->EnableWindow(bFlag);
	// Sets the driving button.
	((CButton*)GetDlgItem(IDC_CW))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_CCW))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_STOP))->EnableWindow(bFlag);
	// Sets the edit box for the driving parameter.
	((CEdit*)GetDlgItem(IDC_LSPEED))->EnableWindow(bFlag);
	((CEdit*)GetDlgItem(IDC_RATE))->EnableWindow(bFlag);
	((CEdit*)GetDlgItem(IDC_SPEED))->EnableWindow(bFlag);
	// Sets the button for changing over the driving mode.
	((CButton*)GetDlgItem(IDC_MODE_CONT))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_MODE_STEP))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_MODE_ORG))->EnableWindow(bFlag);
	((CEdit*)GetDlgItem(IDC_STEP))->EnableWindow(FALSE);
	if (bFlag == TRUE) {
		((CEdit*)GetDlgItem(IDC_STEP))    -> EnableWindow( ((CButton*)GetDlgItem(IDC_MODE_STEP))->GetCheck() == 1);
	}
	// Sets the button for changing the position.
	((CButton*)GetDlgItem(IDC_SET_POSITION)) -> EnableWindow(bFlag);
}

void CD92RS232CControlDlg::SetButtonCaption(BOOL bOrgFlag){
//
// Determines Valid or Invalid of each driving button according to the driving mode selected.
//
	if (bOrgFlag == TRUE) {
		// Indicates "Origin reversion starts" on both the CW and CCW driving buttons when the ORG mode has been selected.
		((CButton*)GetDlgItem(IDC_CW ))->SetWindowText("Origin");
		((CButton*)GetDlgItem(IDC_CCW))->SetWindowText("Origin");
	}
	else{
		// Indicates the direction of movement on each driving button when the other mode has been selected.
		((CButton*)GetDlgItem(IDC_CW ))->SetWindowText("Move(+)>>>");
		((CButton*)GetDlgItem(IDC_CCW))->SetWindowText("<<<Move(-)");
	}
}

BOOL CD92RS232CControlDlg::Connect(int iPortNumber){
//
// Commport connection processing
//
	if (m_MSComm.GetPortOpen() == TRUE){
		// Cuts off the connection if MSComm has been connected to the controller.
		m_MSComm.SetPortOpen(FALSE);
	}

	//	Initialize the MSComm.
	m_MSComm.SetCommPort(iPortNumber);
    m_MSComm.SetInputLen(0);
	m_MSComm.SetEOFEnable(FALSE);
	m_MSComm.SetSettings("9600,N,8,1");
	m_MSComm.SetInputMode(1);

	CException e;								
	TRY{
		m_MSComm.SetPortOpen(TRUE);				
		bConnect = TRUE;						
		m_MSComm.SetInBufferCount(0);
	}
	CATCH(CException,e){						
		e->Delete();							
		bConnect = FALSE;						
		return FALSE;
	}
	END_CATCH

	SetEnableControl(TRUE);						
	return TRUE;
}
	
int CD92RS232CControlDlg::GetPositionData(){
//
// Receives the coordinate data from the controller.
//
	CString strPosition;

	if (SendString("?"+GetAxisString()) == FALSE){	
		m_strStatus = "Commport character string transmission error";
		UpdateData(FALSE);
		return 0;
	}
	if (ReceiveString(strPosition)== FALSE) {
		m_strStatus = "Commport character string receiving error";
		UpdateData(FALSE);
		return 0;
	}
	return atoi(strPosition);
}	

void CD92RS232CControlDlg::OnSelchangePortNumber() 
{
	//
	// Re-connects and confirms MSComm when the port number has been changed.
	//
	int iPortNumber;
	iPortNumber = ((CComboBox*)GetDlgItem(IDC_COMMPORT_NUMBER))->GetCurSel();
	if (Connect(iPortNumber+1)==TRUE) {
		SetEnableControl(TRUE);
		m_strStatus = "Commport connection has been completed.";
	}
	else {
		SetEnableControl(FALSE);
		((CButton*)GetDlgItem(IDOK))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDCANCEL))->EnableWindow(TRUE);
		m_strStatus = "Commport can not be connect.";
	}
	OnSelchangeAxis();
}

void CD92RS232CControlDlg::OnSelchangeAxis() 
{
	SendString(GetAxisString());
	GetAxisStatus();
	m_iPosition = GetPositionData();
	UpdateData(FALSE);
}

int CD92RS232CControlDlg::GetAxisStatus(){
// Obtains the status of the selected axis.
// Return value : -1  Cannot communicate on GPIB
//              :  0  Stop state
//              :  1  On moving
//              :  2  CW limit detection
//              :  3  CCW limit detection
//              :  4  Stop at the origin position
//              : 10  Axis selection impossible

	CString strStatus;
	int iStatus = 0;

	// Obtaining and confirmation of the status

	if (SendString ("%"+GetAxisString())==FALSE){
		m_strStatus = "Commport character string transmission error";
		return -1;
	}
	if (ReceiveString(strStatus) == FALSE){
		m_strStatus = "Commport character string receiving error";
		return -1;
	}
	if (strStatus[0] & 0x80) {
		m_strStatus = "On moving";
		return 1;
	}
	if ((strStatus[0] & 0x18) == 0x18) {
		m_strStatus = "The axis cannot be selected.";
		return 10;
	}
	if (strStatus[0] & 0x10) {
		m_strStatus = "CW limit detection";
		return 2;
	}
	if (strStatus[0] & 0x08) {
		m_strStatus = "CCW limit detection";
		return 3;
	}
	if (strStatus[0] & 0x40) {
		m_strStatus = "Origin position";
		return 4;
	}
	m_strStatus = "Stop";
	return 0;
}

BOOL CD92RS232CControlDlg::SendString(CString strMessage){
//
// Transmits a character string to the Commport.
//
	_variant_t vCommand;
	COleSafeArray oleArray;
	LPBYTE pRecvBytes;
	time_t tStart,tNow;
	BOOL bSuccess = TRUE;

	if (!bConnect) return FALSE;				// When not being connected to the device
	time(&tStart);								// Sets Start time

	for (int i=0;i<strMessage.GetLength();i++){
		vCommand.SetString(CString(strMessage[i]));
		m_MSComm.SetOutput(vCommand);			
		oleArray.Clear();
		do{
			if(m_MSComm.GetInBufferCount()>1){				// Judges whether two characters (">"+CR) have gathered in the receiving buffer
				oleArray = m_MSComm.GetInput();				// Dummy-leads the character string if two characters have gathered
				oleArray.AccessData((void**)&pRecvBytes);
				if (pRecvBytes[0] != '>' ||	pRecvBytes[1] != 0x0d)	bSuccess = FALSE;
				oleArray.UnaccessData();
				break;
			}
			time(&tNow);												
			if (difftime(tNow,tStart) > LIMIT_TIME) bSuccess = FALSE;	// if the time limit is over,Stop the transmission of the character string
		}while (bSuccess == TRUE);
		if (bSuccess == FALSE) break;
	}
	if (bSuccess == TRUE) {
		vCommand.SetString("\r");										// If the character string has been transmitted up to its end, terminates the operation regularly by sending CR
		m_MSComm.SetOutput(vCommand);
	}
	return bSuccess;
}

BOOL CD92RS232CControlDlg::ReceiveString(CString& strMessage){
//
// Receives the character string from commport.
//
	COleSafeArray oleArray;					
	LPBYTE pRecvBytes;						
	time_t tStart,tNow;						
	BOOL bSuccess=FALSE;					

	strMessage="";							
	time(&tStart);							// Sets the start time

	do{
		if (m_MSComm.GetInBufferCount()>0){							
			oleArray = m_MSComm.GetInput();							// Receives from MSComm
			oleArray.AccessData((void**)&pRecvBytes);				
			unsigned int nArrayCount = oleArray.GetOneDimSize();	
			for (unsigned int i=0;i<nArrayCount;i++){
				strMessage += pRecvBytes[i];						// Comm|[gMstrMessageɊi[
			}
			oleArray.UnaccessData();								// zւ̃ANZXI
			if (pRecvBytes[i-1] == 0x0d){							// if the received data is delimiter
				bSuccess = TRUE;
				break;
			}
		}
		time (&tNow);												// Gets the this time
	}while(difftime(tNow,tStart) < LIMIT_TIME);						// if the limit time is over,exits from loop
	bConnect = bSuccess;
	return bSuccess;
}

CString CD92RS232CControlDlg::GetAxisString(){
//
// Returns the axis-designated character string of the axis which is selected by the ComboBox.
//
	CString strAxis = "XY";
	return strAxis.Mid( ((CComboBox*)GetDlgItem(IDC_AXIS)) -> GetCurSel() , 1);
}

void CD92RS232CControlDlg::CheckStop(){
//
// Confirms the stoppage of the stage
//
	CString strMessage;
	MSG msg;
	BOOL bSuccess = FALSE;
	nTimerID=SetTimer(nTimerID,300,NULL);	
	
	while(1) {
		if(SendString("%"+GetAxisString())==FALSE) break;			// Obtains the status
		if(ReceiveString(strMessage)==FALSE) break;				
		if (strMessage[0] & 0x80){									// Exits from the lkoop when the stoppage of the status has been confirmed
			while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != 0){	
				TranslateMessage(&msg);	
				DispatchMessage(&msg);
			}
		}
		else {
			bSuccess = TRUE;										// Xe[^X`̍ŏʃrbgOȂ烋[v𔲂
			break;
		}
	}
	KillTimer(nTimerID);			
	SetEnableControl(TRUE);			
	if (bSuccess == FALSE){
		m_strStatus = "Commport communication error";
		UpdateData(FALSE);
		return;
	}
	OnTimer(NULL);				// Update window
}

void CD92RS232CControlDlg::SetPositionData(int iPositionData){
//
// Changes the position of the stage.
//
	CString strMessage;
	if (iPositionData <0)	strMessage.Format("SL%d",-iPositionData);
	else					strMessage.Format("S%d",iPositionData);
	SendString(GetAxisString()+strMessage);
}

// << SURUGA
